From 25ae719d1208f19f5200943e449dc3e2fed8e676 Mon Sep 17 00:00:00 2001
From: Sirajudeen <sirajudeen.yasin@gmail.com>
Date: Wed, 6 Jan 2021 20:46:41 +0000
Subject: [PATCH] Wait for CR tigerastatus to be available

* Wait for CRD's Established state.
* Wait for CR tigerastatus to show up in api to query
* Once CR is created, wait for its condition to be available.

Change-Id: Ibb83e16a15a7e0e351b6ae030e3e82ce22d41c70
Closes: #442
---
 .../26_deploy_capi_ephemeral_node.sh          | 20 ++++++++++++++++---
 .../31_deploy_initinfra_target_node.sh        | 20 ++++++++++++++++---
 2 files changed, 34 insertions(+), 6 deletions(-)

diff --git a/tools/deployment/26_deploy_capi_ephemeral_node.sh b/tools/deployment/26_deploy_capi_ephemeral_node.sh
index f33f1784d..7fd9d584e 100755
--- a/tools/deployment/26_deploy_capi_ephemeral_node.sh
+++ b/tools/deployment/26_deploy_capi_ephemeral_node.sh
@@ -26,9 +26,23 @@ if [ "$PROVIDER" = "metal3" ]; then
     echo "Wait for Calico to be deployed using tigera"
     kubectl --kubeconfig $KUBECONFIG --context $KUBECONFIG_EPHEMERAL_CONTEXT wait --all-namespaces --for=condition=Ready pods --all --timeout=1000s
 
-    # Skipping this check due a race condition till a work-around is identified.
-    #echo "Wait for Tigerastatus to be Available"
-    #kubectl --kubeconfig $KUBECONFIG --context $KUBECONFIG_EPHEMERAL_CONTEXT wait --for=condition=Available tigerastatus --all --timeout=1000s -A
+    echo "Wait for Established condition of tigerastatus(CRD) to be true for tigerastatus(CR) to show up"
+    kubectl --kubeconfig $KUBECONFIG --context $KUBECONFIG_EPHEMERAL_CONTEXT wait --for=condition=Established crd/tigerastatuses.operator.tigera.io --timeout=300s
+
+    # Wait till CR(tigerastatus) shows up to query
+    count=0
+    max_retry_attempts=150
+    until [[ $(kubectl --kubeconfig $KUBECONFIG --context $KUBECONFIG_EPHEMERAL_CONTEXT get tigerastatus 2>/dev/null) ]]; do
+      count=$((count + 1))
+      if [[ ${count} -eq "${max_retry_attempts}" ]]; then
+        echo ' Timed out waiting for tigerastatus'
+        exit 1
+      fi
+      sleep 2
+    done
+
+    # Wait till condition is available for tigerastatus
+    kubectl --kubeconfig $KUBECONFIG --context $KUBECONFIG_EPHEMERAL_CONTEXT wait --for=condition=Available tigerastatus --all --timeout=1000s
 
     echo "Deploy metal3.io components to ephemeral node"
     airshipctl phase run initinfra-ephemeral --debug
diff --git a/tools/deployment/31_deploy_initinfra_target_node.sh b/tools/deployment/31_deploy_initinfra_target_node.sh
index 8acb0b7fa..09c7f715b 100755
--- a/tools/deployment/31_deploy_initinfra_target_node.sh
+++ b/tools/deployment/31_deploy_initinfra_target_node.sh
@@ -23,9 +23,23 @@ airshipctl phase run initinfra-networking-target --debug
 echo "Wait for Calico to be deployed using tigera"
 kubectl --kubeconfig $KUBECONFIG --context $KUBECONFIG_TARGET_CONTEXT wait --all-namespaces --for=condition=Ready pods --all --timeout=600s
 
-# Skipping this check due a race condition till a work-around is identified.
-#echo "Wait for Tigerastatus to be available"
-#kubectl --kubeconfig $KUBECONFIG --context $KUBECONFIG_TARGET_CONTEXT wait --for=condition=Available tigerastatus --all --timeout=600s -A
+echo "Wait for Established condition of tigerastatus(CRD) to be true for tigerastatus(CR) to show up"
+kubectl --kubeconfig $KUBECONFIG --context $KUBECONFIG_TARGET_CONTEXT wait --for=condition=Established crd/tigerastatuses.operator.tigera.io --timeout=300s
+
+# Wait till CR(tigerastatus) is available
+count=0
+max_retry_attempts=150
+until [[ $(kubectl --kubeconfig $KUBECONFIG --context $KUBECONFIG_TARGET_CONTEXT get tigerastatus 2>/dev/null) ]]; do
+  count=$((count + 1))
+  if [[ ${count} -eq "${max_retry_attempts}" ]]; then
+    echo ' Timed out waiting for tigerastatus'
+    exit 1
+  fi
+  sleep 2
+done
+
+# Wait till condition is available for tigerastatus
+kubectl --kubeconfig $KUBECONFIG --context $KUBECONFIG_TARGET_CONTEXT wait --for=condition=Available tigerastatus --all --timeout=1000s
 
 echo "Deploy infra to cluster"
 airshipctl phase run initinfra-target --debug